Subject: 26.0.50; Tramp tests are slow
From: Gemini Lasswell <[email-masked]>
To: [email-masked]
Date: Thu, 24 Aug 2017 14:03:32 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

The Tramp tests are the slowest tests in Emacs's test suite, even when
they aren't set up to access a remote machine.

After a little investigation I think the cause of the slowness is
excessive memory allocation. I modified ert-run-tests to print
memory statistics after each test and found that tramp-tests.el, which
takes 100 seconds to run on my machine, is spending 39 seconds doing
garbage collection, and by the end of the test run has allocated and
freed 27 million strings.

Here is a log file with memory statistics:

And here are the messages I added to ert-run-test's loop:

(message "GC: %s" (garbage-collect))
(message "GC count: %s time: %s" gcs-done gc-elapsed)
(message "Memory-use-counts: %s" (memory-use-counts))